public inbox for fstests@vger.kernel.org
 help / color / mirror / Atom feed
From: Josef Bacik <josef@toxicpanda.com>
To: kernel-team@fb.com, david@fromorbit.com, fstests@vger.kernel.org,
	tytso@mit.edu, eguan@redhat.com, darrick.wong@oracle.com
Cc: Josef Bacik <jbacik@fb.com>
Subject: [PATCH 2/2][v4] perf/001: a random write buffered fio perf test
Date: Tue,  7 Nov 2017 16:53:33 -0500	[thread overview]
Message-ID: <1510091613-17357-2-git-send-email-josef@toxicpanda.com> (raw)
In-Reply-To: <1510091613-17357-1-git-send-email-josef@toxicpanda.com>

From: Josef Bacik <jbacik@fb.com>

This uses the new fio results perf helpers to run a rand write buffered
workload on the scratch device.

Signed-off-by: Josef Bacik <jbacik@fb.com>
---
v3->v4:
- use _require_fs_space instead of _scratch_mkfs_sized.
- remove run_check from running fio.

v2->v3:
- use _scratch_mkfs_sized so we skip if our scratch device is too small.
- dump the fio results into teh seqres.full file for debugging.
- fixed the _size math, it was all wrong.

v1->v2:
- no change

 tests/perf/001     | 80 ++++++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/perf/001.out |  2 ++
 tests/perf/group   |  1 +
 3 files changed, 83 insertions(+)
 create mode 100644 tests/perf/001
 create mode 100644 tests/perf/001.out
 create mode 100644 tests/perf/group

diff --git a/tests/perf/001 b/tests/perf/001
new file mode 100644
index 000000000000..a9e933df7791
--- /dev/null
+++ b/tests/perf/001
@@ -0,0 +1,80 @@
+#! /bin/bash
+# perf/001 Test
+#
+# Buffered random write performance test.
+#
+#-----------------------------------------------------------------------
+# (c) 2017 Josef Bacik
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+fio_config=$tmp.fio
+fio_results=$tmp.json
+status=1	# failure is the default!
+trap "rm -f $tmp.*; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/perf
+
+# real QA test starts here
+_supported_fs generic
+_supported_os Linux
+_require_scratch
+_require_block_device $SCRATCH_DEV
+_require_fio_results
+
+rm -f $seqres.full
+
+_size=$((16 * $LOAD_FACTOR))
+cat >$fio_config <<EOF
+[t1]
+directory=${SCRATCH_MNT}
+allrandrepeat=1
+readwrite=randwrite
+size=${_size}G
+ioengine=psync
+end_fsync=1
+fallocate=none
+EOF
+
+_require_fio $fio_config
+
+_fio_results_init
+
+# We are going to write at least 16gib, make sure our scratch fs is large enough
+# to fit and not deal with any enospc overhead.
+_size=$(($_size * 4 * 1024 * 1024))
+_scratch_mkfs >> $seqres.full 2>&1
+_scratch_mount
+_require_fs_space $SCRATCH_MNT $_size
+
+cat $fio_config >> $seqres.full
+$FIO_PROG --output-format=json --output=$fio_results $fio_config
+
+_scratch_unmount
+cat $fio_results >> $seqres.full
+_fio_results_compare $seq $fio_results
+echo "Silence is golden"
+status=0; exit
diff --git a/tests/perf/001.out b/tests/perf/001.out
new file mode 100644
index 000000000000..88678b8ed5ad
--- /dev/null
+++ b/tests/perf/001.out
@@ -0,0 +1,2 @@
+QA output created by 001
+Silence is golden
diff --git a/tests/perf/group b/tests/perf/group
new file mode 100644
index 000000000000..d3ed434926e7
--- /dev/null
+++ b/tests/perf/group
@@ -0,0 +1 @@
+001 auto
-- 
2.7.5


  reply	other threads:[~2017-11-07 21:53 UTC|newest]

Thread overview: 6+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2017-11-07 21:53 [PATCH 1/2][v4] fstests: add fio perf results support Josef Bacik
2017-11-07 21:53 ` Josef Bacik [this message]
2017-11-16  5:22 ` Eryu Guan
2017-11-16 15:44   ` Josef Bacik
2017-11-16 16:47 ` Darrick J. Wong
2017-11-16 18:01   ` Josef Bacik

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1510091613-17357-2-git-send-email-josef@toxicpanda.com \
    --to=josef@toxicpanda.com \
    --cc=darrick.wong@oracle.com \
    --cc=david@fromorbit.com \
    --cc=eguan@redhat.com \
    --cc=fstests@vger.kernel.org \
    --cc=jbacik@fb.com \
    --cc=kernel-team@fb.com \
    --cc=tytso@mit.edu \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox